"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.miniEspParser = void 0;
var LEDEnum;
(function (LEDEnum) {
    LEDEnum[LEDEnum["red"] = 1] = "red";
    LEDEnum[LEDEnum["green"] = 2] = "green";
    LEDEnum[LEDEnum["blue"] = 3] = "blue";
})(LEDEnum || (LEDEnum = {}));
let modelObj = {
    PuckLEDon(color) {
        return `LED${LEDEnum[color]}.set();`;
    },
    PuckLEDoff(color) {
        return `LED${LEDEnum[color]}.reset();`;
    },
    PuckLEDtoggle(color) {
        return `LED${LEDEnum[color]}.toggle();`;
    },
    PuckLEDflash(color, ms) {
        return `digitalPulse(LED${LEDEnum[color]},1,${ms});`;
    },
    PuckLEDval(color) {
        return `digitalRead(LED${color}) == 1;`;
    },
    PuckNFCsetUrl(url) {
        return `NRF.nfcURL(${url});`;
    },
    PuckNFCreset() {
        return `NRF.nfcURL();`;
    },
    PuckIRtransmit(data) {
        return `Puck.IR([${data.join(',')}]);`;
    },
    PuckMagenableMag() {
        return `Puck.magOn();`;
    },
    PuckMagenableField() {
        return `require("puckjsv2-mag-level").on();`;
    },
    PuckMagdisableMag() {
        return `Puck.magOff();`;
    },
    PuckMagdisableField() {
        return `require("puckjsv2-mag-level").off();`;
    },
    PuckgetLightVal() {
        return `Puck.light();`;
    },
    PuckaccelenableAccelMovement() {
        return `require("puckjsv2-accel-movement").on();`;
    },
    PuckaccelenableAccelBigMovement() {
        return `require("puckjsv2-accel-bigmovement").on();`;
    },
    PuckaccelenableAccelTilt() {
        return `require("puckjsv2-accel-tilt").on();`;
    },
    PuckacceldisableAccelMovement() {
        return `require("puckjsv2-accel-movement").off();`;
    },
    PuckacceldisableAccelBigMovement() {
        return `require("puckjsv2-accel-bigmovement").off();`;
    },
    PuckacceldisableAccelTilt() {
        return `require("puckjsv2-accel-tilt").off();`;
    },
    Puckaccelval() {
        return `Puck.accel();`;
    },
    PuckgetTemperature() {
        return `E.getTemperature();`;
    },
    Puckdump() {
        return `E.dumpStr();`;
    },
    Pixldump() {
        return `E.dumpStr();`;
    },
    Bangledump() {
        return `E.dumpStr();`;
    },
    DeviceControllerdump() {
        return `E.dumpStr();`;
    },
    PuckgetDeviceType() {
        return `process.env.BOARD`;
    },
    PixlgetDeviceType() {
        return `process.env.BOARD`;
    },
    BanglegetDeviceType() {
        return `process.env.BOARD`;
    },
    DeviceControllergetDeviceType() {
        return `process.env.BOARD`;
    },
};
function replaceCode(str) {
    let convertedObjName = str.split('(')[0].replace(/\./g, '');
    let params = str.split('(')[1].replace(')', '').replace(/\'/g, '').split(',');
    console.log(modelObj[convertedObjName](...params));
    return '';
}
function miniEspParser(func) {
    let stringified_func = func.toString().split('\n').slice(1, -1).join('\n');
    // This will grab any method call from the code for use in replace
    let deviceObjMethodRegex = /(Puck|Pixl|Bangle|DeviceControl{2}er)+.+[a-zA-Z]+.+[a-zA-Z]+[\((+([a-zA-Z\d.!?\\\"\'-\\\(\s\)]+\)|\)];/g;
    return stringified_func.replace(deviceObjMethodRegex, (e) => replaceCode(e));
}
exports.miniEspParser = miniEspParser;
let code = function () {
    Puck.LED.on('green');
};
